Ruby - Bug #20458

OpensSSL::SSL::SSLContext#min_version= and #max_version no longer accept Symbol values
04/25/2024 08:45 PM - postmodern (Hal Brodigan)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 3.3.1 (2024-04-23 revision Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:
€56cd86388) [x86_64-linux] UNKNOWN

Description

It appears that OpenSSL::SSL::SSLContext#min_version= and #max_version= no longer accept Symbol values, contrary to their
documentation. Instead it appears they are being converted to Strings.

Steps To Reproduce

require 'openssl'
context = OpenSSL::SSL::SSLContext.new
context.min_version = :TLSvl

require 'openssl'

context = OpenSSL::SSL::SSLContext.new
context.max_version = :TLSv1_2

Expected Results

Sets min_version and max_version to the according OpenSSL::SSL::TLS1_VERSION and OpenSSL::SSL::TLS1_2_VERSION
values, respectively.

Actual Results

/usr/share/ruby/openssl/ssl.rb:179:in 'set_minmax_proto_version': unrecognized version "TLSv1l" (Ar
gumentError)

set_minmax_proto_version (version, @max_proto_version ||= nil)
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

from /usr/share/ruby/openssl/ssl.rb:179:in "min_version="'

/usr/share/ruby/openssl/ssl.rb:191:in 'set_minmax_proto_version': unrecognized version "TLSv1_2" (
ArgumentError)

set_minmax_proto_version (@min_proto_version ||= nil, version)
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

from /usr/share/ruby/openssl/ssl.rb:191:in ‘max_version="'

Version Info
Tested on:

e ruby 3.2.2 (2023-03-30 revision €51014f9¢0) [x86_64-linux] and openssl gem version 3.1.0
¢ ruby 3.3.1 (2024-04-23 revision c56¢cd86388) [x86_64-linux] and openssl gem version 3.2.0

History

#1 - 04/25/2024 09:42 PM - postmodern (Hal Brodigan)

Ah | see the problem now. OpenSSL::SSL::SSLContext#ssl_version accepts :TLSv1* symbols, but #min_version and #max_version only seem to
accept :TLS1* symbols without the v. This seems inconsistent and prone to causing confusion.

#2 - 04/25/2024 09:58 PM - postmodern (Hal Brodigan)

Also | just now noticed that SSLContext#ss|_version= is deprecated. This issue can be closed.
https://docs.ruby-lang.org/en/master/OpenSSL/SSL/SSLContext.html#method-i-min_version-3D

#3 - 04/25/2024 10:00 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed
